----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:10:08 06/24/2013 
-- Design Name: 
-- Module Name:    pm_test - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity PM_TEST is
  generic (
    pmp_addr : std_logic_vector (15 downto 0) := x"0200");  --Basisadresse auf PMP Bus
  port (
    ACLK   : in  std_logic;
    PADDR  : in  std_logic_vector(15 downto 0);
    PRD    : in  std_logic;
    PRDATA : out std_logic_vector(15 downto 0);
    PWR    : in  std_logic;
	 PWDATA : in  std_logic_vector(15 downto 0));
end pm_test;

architecture Behavioral of PM_TEST is
type speicher is array(0 to (2**8)-1) of STD_LOGIC_VECTOR(15 downto 0);
signal memory : speicher := (
 x"1234", x"1235", x"1236", x"1237", x"1238", x"1239", x"123A", others=>x"1111");   
begin

  PMP : process (ACLK)
  begin
    if rising_edge(ACLK) then
      if(PADDR(15 downto 8) = pmp_addr(15 downto 8))then
			if(PWR = '1') then
				memory(to_integer(unsigned(PADDR(7 downto 0)))) <= PWDATA;
			end if;
			if(PRD = '1') then
				PRDATA <= memory(to_integer(unsigned(PADDR(7 downto 0))));
			else
				PRDATA <= x"0000";
			end if;
		end if;
    end if;
  end process PMP;

end Behavioral;


